//+------------------------------------------------------------------+
//|                                                SemaphorTrue2.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, zznbrm"
                          
//---- indicator settings
#property indicator_chart_window
#property  indicator_buffers 6 
#property  indicator_color1 Lime
#property  indicator_color2 Orange
#property  indicator_color3 Yellow
#property  indicator_color4 Yellow
#property  indicator_color5 Black
#property  indicator_color6 Black
#property  indicator_width1 4
#property  indicator_width2 4
#property  indicator_width3 6
#property  indicator_width4 6
#property  indicator_width5 4
#property  indicator_width6 4

//---- input parameters
extern int eintDepth1 = 34;
extern int eintDepth2 = 34;
extern int eintDepth3 = 55;
extern double edblOffsetPoints = 5.0;

//---- indicator buffers
double gadblUp1[];
double gadblUp2[];
double gadblUp3[];
double gadblDn1[];
double gadblDn2[];
double gadblDn3[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer( 0, gadblUp1 );
   SetIndexEmptyValue( 0, 0.0 );
   SetIndexStyle( 0, DRAW_ARROW );
   SetIndexArrow( 0, 159 ); 
   SetIndexLabel( 0, NULL );

   SetIndexBuffer( 1, gadblUp2 );
   SetIndexEmptyValue( 1, 0.0 );
   SetIndexStyle( 1, DRAW_ARROW );
   SetIndexArrow( 1, 159 ); 
   SetIndexLabel( 1, NULL );
   
   SetIndexBuffer( 2, gadblUp3 );
   SetIndexEmptyValue( 2, 0.0 );
   SetIndexStyle( 2, DRAW_ARROW );
   SetIndexArrow( 2, 159 ); 
   SetIndexLabel( 2, NULL );
   
   SetIndexBuffer( 3, gadblDn1 );
   SetIndexEmptyValue( 3, 0.0 );
   SetIndexStyle( 3, DRAW_ARROW );
   SetIndexArrow( 3, 159 ); 
   SetIndexLabel( 3, NULL );
   
   SetIndexBuffer( 4, gadblDn2 );
   SetIndexEmptyValue( 4, 0.0 );
   SetIndexStyle( 4, DRAW_ARROW );
   SetIndexArrow( 4, 159 ); 
   SetIndexLabel( 4, NULL );
   
   SetIndexBuffer( 5, gadblDn3 );
   SetIndexEmptyValue( 5, 0.0 );
   SetIndexStyle( 5, DRAW_ARROW );
   SetIndexArrow( 5, 159 ); 
   SetIndexLabel( 5, NULL ); 
    
   IndicatorDigits( 5 );
     
   //---- name for DataWindow and indicator subwindow label
   IndicatorShortName( "SemaphorTrue2(" + eintDepth1 + "," + eintDepth2 + "," + eintDepth3 + ")" );
   
   return( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return( 0 );
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars = IndicatorCounted();
   
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int intLimit = Bars - counted_bars;
   int intLow1, intLow2, intLow3, intHigh1, intHigh2, intHigh3;

   for( int inx = intLimit; inx >= 0; inx-- )
   {          
      gadblUp1[inx] = 0.0;  gadblUp2[inx] = 0.0;    gadblUp3[inx] = 0.0;
      gadblDn1[inx] = 0.0;  gadblDn2[inx] = 0.0;    gadblDn3[inx] = 0.0;
      
      intLow1 = iLowest( Symbol(), Period(), MODE_LOW, eintDepth1, inx );
      intLow2 = iLowest( Symbol(), Period(), MODE_LOW, eintDepth2, inx );
      intLow3 = iLowest( Symbol(), Period(), MODE_LOW, eintDepth3, inx );
      
      if ( intLow3 == inx )
      {
         gadblUp3[inx] = Low[inx] - (edblOffsetPoints*Point);
      }
      else if ( intLow2 == inx )
      {
         gadblUp2[inx] = Low[inx] - (edblOffsetPoints*Point);
      }
      else if ( intLow1 == inx )
      {
         gadblUp1[inx] = Low[inx] - (edblOffsetPoints*Point);
      }
      
      intHigh1 = iHighest( Symbol(), Period(), MODE_HIGH, eintDepth1, inx );
      intHigh2 = iHighest( Symbol(), Period(), MODE_HIGH, eintDepth2, inx );
      intHigh3 = iHighest( Symbol(), Period(), MODE_HIGH, eintDepth3, inx );
      
      if ( intHigh3 == inx )
      {
         gadblDn3[inx] = High[inx] + (edblOffsetPoints*Point);
      }
      else if ( intHigh2 == inx )
      {
         gadblDn2[inx] = High[inx] + (edblOffsetPoints*Point);
      }
      else if ( intHigh1 == inx )
      {
         gadblDn1[inx] = High[inx] + (edblOffsetPoints*Point);
      }
   }
   
   return( 0 );
}

